{***************************************************************
 *
 * Unit Name : AgendaPersonala
 * Purpose   : Personal Phone Book
 * Author    : Eugen Mihailescu
 * Company   : EM Quicksoft Romania SRL
 * Copyright : 1998,2002  All rights reserved.
 * Web Site  : http://www.em-quicksoft.com
 * Support   : support@em-quicksoft.com
 * History   : 03/17/2000
 *
 * Disclaimer: The objectives of this program is only educational.
 *             You MUST NOT use it without getting any material benefit on it
 *             You have the right to share this code with others without removing
 *             the copyright and/or disclaimer notice.
 *             You are allowed to include its code in your application
 *             only if it was designed for non commercial purpose,
 *             otherwise we claim $10 for each copy of your
 *             application which contains this code inside.
 ****************************************************************}

Unit AgendaPersonala;

Interface

Uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  ComCtrls,
  ExtCtrls,
  DBCtrls,
  Mask,
  Grids,
  DBGrids,
  StdCtrls,
  Db,
  DBTables,
  Buttons,
  IniFiles;

Type
  TMyCustomDBEdit = Class(TDBEdit)
  private
  protected
    Procedure WMCopy(Var Message: TMessage); message WM_COPY;
  End;

  TfrmPersAgendBook = Class(TForm)
    pagcData: TPageControl;
    tabsGeneral: TTabSheet;
    tabsDetail: TTabSheet;
    tabsUtility: TTabSheet;
    grpFilter: TGroupBox;
    lblCity: TLabel;
    edtCity: TEdit;
    edtName: TEdit;
    lblName: TLabel;
    edtSurname: TEdit;
    lblSurname: TLabel;
    lblStreet: TLabel;
    edtStreet: TEdit;
    lblNo: TLabel;
    edtStreetNo: TEdit;
    lblAltSurname: TLabel;
    edtAltSurname: TEdit;
    lblZIPCode: TLabel;
    edtZipCode: TEdit;
    lblPhoneNo: TLabel;
    edtPhonePrefix: TEdit;
    edtPhoneNo: TEdit;
    lblSep1: TLabel;
    chkIgnoreCase: TCheckBox;
    dgrData: TDBGrid;
    GroupBox2: TGroupBox;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    stbStatus: TStatusBar;
    btnradFiltred: TRadioButton;
    btnradAllRec: TRadioButton;
    btnFinish: TButton;
    dsData: TDataSource;
    tblData: TTable;
    btnspdA: TSpeedButton;
    btnspdB: TSpeedButton;
    btnspdC: TSpeedButton;
    btnspdD: TSpeedButton;
    btnspdG: TSpeedButton;
    btnspdH: TSpeedButton;
    btnspdF: TSpeedButton;
    btnspdE: TSpeedButton;
    btnspdO: TSpeedButton;
    btnspdP: TSpeedButton;
    btnspdN: TSpeedButton;
    btnspdM: TSpeedButton;
    btnspdL: TSpeedButton;
    btnspdK: TSpeedButton;
    btnspdJ: TSpeedButton;
    btnspdI: TSpeedButton;
    btnspd2: TSpeedButton;
    btnspd3: TSpeedButton;
    btnspdZ: TSpeedButton;
    btnspdY: TSpeedButton;
    btnspdX: TSpeedButton;
    btnspdW: TSpeedButton;
    btnspdV: TSpeedButton;
    btnspdU: TSpeedButton;
    btnspdQ: TSpeedButton;
    btnspdR: TSpeedButton;
    btnspdS: TSpeedButton;
    btnspdT: TSpeedButton;
    btnspd0: TSpeedButton;
    btnspd1: TSpeedButton;
    btnspd4: TSpeedButton;
    btnspd5: TSpeedButton;
    btnspd6: TSpeedButton;
    btnspd7: TSpeedButton;
    btnspd9: TSpeedButton;
    btnspd8: TSpeedButton;
    DBNavigator1: TDBNavigator;
    chkPartialCompare: TCheckBox;
    TabSheet1: TTabSheet;
    tblDataNume: TStringField;
    tblDataPrenume: TStringField;
    tblDataPrenumeExt: TStringField;
    tblDataLocalitatea: TStringField;
    tblDataStrada: TStringField;
    tblDataNrStrada: TStringField;
    tblDataCodLocalitate: TStringField;
    tblDataPrefixTelefon: TStringField;
    tblDataTelefon: TStringField;
    tblDataBloc: TStringField;
    tblDataScara: TStringField;
    tblDataEtaj: TStringField;
    tblDataApartament: TStringField;
    Procedure ModifyFilter(Sender: TObject);
    Procedure btnFinishClick(Sender: TObject);
    Procedure chkIgnoreCaseClick(Sender: TObject);
    Procedure chkPartialCompareClick(Sender: TObject);
    Procedure btnradAllRecClick(Sender: TObject);
    Procedure FormShow(Sender: TObject);
    Procedure btnspdAClick(Sender: TObject);
    Procedure FormCreate(Sender: TObject);
    Procedure FormClose(Sender: TObject; Var Action: TCloseAction);
    Procedure dgrDataCellClick(Column: TColumn);
    Procedure dgrDataKeyUp(Sender: TObject; Var Key: Word;
      Shift: TShiftState);
    Procedure FormDestroy(Sender: TObject);
    Procedure DBNavigator1Click(Sender: TObject; Button: TNavigateBtn);
  private
    Function GetFilter: String;
    Procedure InitButtonsHint;
    Procedure OpenContactsBook(Value: String);
    Procedure Init;
    Procedure SaveSettings;
    Procedure LoadSettings;
  public
  End;

Var
  frmPersAgendBook  : TfrmPersAgendBook;

Const
  FilterFld         : Array[0..9] Of String = ('Localitatea', 'Judetul', 'Strada', 'NrStrada', 'CodLocalitate', 'Nume', 'Prenume', 'PrenumeExt', 'PrefixTelefon', 'Telefon');

Procedure Register;

Implementation

Uses RefreshAgendaDataDlg;

{$R *.DFM}
//******************* TfrmPersAgendBook.btnFinishClick *************************

Procedure TfrmPersAgendBook.btnFinishClick(Sender: TObject);
Begin
  Close;
End;
//******************* TfrmPersAgendBook.ModifyFilter *************************

Procedure TfrmPersAgendBook.ModifyFilter(Sender: TObject);
Begin
  btnradAllRec.Checked := True;
  If btnradAllRec.Checked Then
    tblData.FindNearest([edtName.Text, edtSurname.Text, edtAltSurname.Text, edtCity.Text, edtStreet.Text, edtStreetNo.Text, edtZipCode.Text, edtPhonePrefix.Text, edtPhoneNo.Text]);
End;
//******************* TfrmPersAgendBook.GetFilter *************************

Function TfrmPersAgendBook.GetFilter: String;
Var
  I                 : Integer;
Begin
  Result := '';
  For I := 0 To grpFilter.ControlCount - 1 Do
    If grpFilter.Controls[I] Is TEdit Then
      If (grpFilter.Controls[I] As TEdit).Text <> '' Then
        If Result <> '' Then
          Result := Format('%s AND %s=''%s''', [Result, FilterFld[grpFilter.Controls[I].Tag], (grpFilter.Controls[I] As TEdit).Text])
        Else
          Result := Format('%s=''%s''', [FilterFld[grpFilter.Controls[I].Tag], (grpFilter.Controls[I] As TEdit).Text]);
End;
//******************* TfrmPersAgendBook.chkIgnoreCaseClick *************************

Procedure TfrmPersAgendBook.chkIgnoreCaseClick(Sender: TObject);
Begin
  If chkIgnoreCase.Checked Then
    tblData.FilterOptions := tblData.FilterOptions + [foCaseInsensitive]
  Else
    tblData.FilterOptions := tblData.FilterOptions - [foCaseInsensitive];
End;
//******************* TfrmPersAgendBook.chkPartialCompareClick *************************

Procedure TfrmPersAgendBook.chkPartialCompareClick(Sender: TObject);
Begin
  If Not chkPartialCompare.Checked Then
    tblData.FilterOptions := tblData.FilterOptions + [foNoPartialCompare]
  Else
    tblData.FilterOptions := tblData.FilterOptions - [foNoPartialCompare];
End;
//******************* TfrmPersAgendBook.btnradAllRecClick *************************

Procedure TfrmPersAgendBook.btnradAllRecClick(Sender: TObject);
Begin
  frmWait := TfrmWait.Create(Self);
  Try
    frmWait.Show;
    frmWait.Update;
    tblData.DisableControls;
    tblData.Filtered := btnradFiltred.Checked;
    If tblData.Filtered Then
      Begin
        stbStatus.Panels[1].Text := 'Filtrare date in executie...';
        stbStatus.Update;
        tblData.Filter := GetFilter;
      End
    Else
      tblData.Filter := '';
    stbStatus.Panels[1].Text := '';
    tblData.EnableControls;
    frmWait.Close;
  Finally
    frmWait.Free;
  End;
End;
//******************* TfrmPersAgendBook.InitButtonsHint *************************

Procedure TfrmPersAgendBook.InitButtonsHint;
Var
  I                 : Integer;
Begin
  For I := 0 To tabsGeneral.ControlCount - 1 Do
    If tabsGeneral.Controls[I] Is TSpeedButton Then
      (tabsGeneral.Controls[I] As TSpeedButton).Hint := (tabsGeneral.Controls[I] As TSpeedButton).Caption;
End;
//******************* TfrmPersAgendBook.FormShow *************************

Procedure TfrmPersAgendBook.FormShow(Sender: TObject);
Begin
  InitButtonsHint;
  pagcData.ActivePageIndex := 0;
End;
//******************* TfrmPersAgendBook.OpenContactsBook *************************

Procedure TfrmPersAgendBook.OpenContactsBook(Value: String);
Begin
  With tblData Do
    Begin
      Active := False;
      Filtered := False;
      Filter := '';
      TableName := Value;
      Active := Exists;
    End;
End;
//******************* TfrmPersAgendBook.btnspdAClick *************************

Procedure TfrmPersAgendBook.btnspdAClick(Sender: TObject);
Begin
  stbStatus.Panels[1].Text := 'Activare dictionar in executie...';
  stbStatus.Update;
  With Sender As TSpeedButton Do
    OpenContactsBook(Caption);
  btnradAllRec.Checked := True;
  stbStatus.Panels[1].Text := '';
  stbStatus.Update;
End;
//******************* TfrmPersAgendBook.Init *************************

Procedure TfrmPersAgendBook.Init;
Var
  I                 : Integer;
Begin
  If Not Session.IsAlias('PersonalAddressBook') Then
    Session.AddStandardAlias('PersonalAddressBook', ExtractFilePath(Application.ExeName) + 'Data', 'PARADOX');
  tblData.DatabaseName := 'PersonalAddressBook';
  For I := 0 To tabsGeneral.ControlCount - 1 Do
    If tabsGeneral.Controls[I] Is TSpeedButton Then
      If (tabsGeneral.Controls[I] As TSpeedButton).Down Then
        OpenContactsBook((tabsGeneral.Controls[I] As TSpeedButton).Caption);
  chkIgnoreCaseClick(Self);
  chkPartialCompareClick(Self);
  For I := 0 To 12 Do
    With TMyCustomDBEdit.Create(Self) Do
      Begin
        Parent := GroupBox2;
        DataSource := dsData;
        DataField := tblData.FieldDefs.Items[I].DisplayName;
        Case I Of
          0..4: Top := 24 * (I + 1);
          5: Top := 120;
          6: Top := 144;
          7, 8: Top := 168;
          9..12: Top := 24 * (I - 1);
        End;

        Left := 128;
        Case I Of
          0..4, 6: Width := 217;
          5: Width := 65;
          7, 9..12: Width := 81;
          8: Width := 113;
        End;

        Case I Of
          5: Left := 376;
          8: Left := 232;
        End;
      End;
  LoadSettings;
End;
//******************* TfrmPersAgendBook.FormCreate *************************

Procedure TfrmPersAgendBook.FormCreate(Sender: TObject);
Begin
  RegisterClass(TMyCustomDBEdit);
  Init;
End;
//******************* TfrmPersAgendBook.FormClose *************************

Procedure TfrmPersAgendBook.FormClose(Sender: TObject;
  Var Action: TCloseAction);
Begin
  tblData.Active := False;
  SaveSettings;
End;
//******************* TfrmPersAgendBook.dgrDataCellClick *************************

Procedure TfrmPersAgendBook.dgrDataCellClick(Column: TColumn);
Begin
  Try
    If tblData.State In [dsFilter, dsOpening] Then Exit;
    If tblData.Active Then
      stbStatus.Panels.Items[2].Text := Format('%d / %d', [tblData.RecNo, tblData.RecordCount])
    Else
      stbStatus.Panels.Items[2].Text := Format('%d / %d', [0, 0]);
  Except
    stbStatus.Panels.Items[2].Text := Format('%d / %d', [0, 0]);
  End;
  Application.ProcessMessages;
End;
//******************* TfrmPersAgendBook.dgrDataKeyUp *************************

Procedure TfrmPersAgendBook.dgrDataKeyUp(Sender: TObject; Var Key: Word;
  Shift: TShiftState);
Begin
  Try
    If tblData.State In [dsFilter, dsOpening] Then Exit;
    If tblData.Active Then
      stbStatus.Panels.Items[2].Text := Format('%d / %d', [tblData.RecNo, tblData.RecordCount])
    Else
      stbStatus.Panels.Items[2].Text := Format('%d / %d', [0, 0]);
  Except
    stbStatus.Panels.Items[2].Text := Format('%d / %d', [0, 0]);
  End;
  Application.ProcessMessages;
End;
//******************* TMyCustomDBEdit.WMCopy *************************

Procedure TMyCustomDBEdit.WMCopy(Var Message: TMessage);
Begin
  Message.Msg := WM_NULL;
End;
//******************* TfrmPersAgendBook.FormDestroy *************************

Procedure TfrmPersAgendBook.FormDestroy(Sender: TObject);
Begin
  UnregisterClass(TMyCustomDBEdit);
End;
//******************* Not available *************************

Procedure Register;
Begin
  RegisterComponents('Standard', [TfrmPersAgendBook]);
End;
//******************* TfrmPersAgendBook.DBNavigator1Click *************************

Procedure TfrmPersAgendBook.DBNavigator1Click(Sender: TObject;
  Button: TNavigateBtn);
Begin
  Try
    If tblData.State In [dsFilter, dsOpening] Then Exit;
    If tblData.Active Then
      stbStatus.Panels.Items[2].Text := Format('%d / %d', [tblData.RecNo, tblData.RecordCount])
    Else
      stbStatus.Panels.Items[2].Text := Format('%d / %d', [0, 0]);
  Except
    stbStatus.Panels.Items[2].Text := Format('%d / %d', [0, 0]);
  End;
  Application.ProcessMessages;
End;
//******************* TfrmPersAgendBook.SaveSettings *************************

Procedure TfrmPersAgendBook.SaveSettings;
Var
  F                 : TIniFile;
Begin
  F := TIniFile.Create(ExtractFilePath(Application.ExeName) + 'Settings');
  Try
    F.WriteBool('Filter', 'IgnoreCase', chkIgnoreCase.Checked);
    F.WriteBool('Filter', 'PartialCompare', chkPartialCompare.Checked);
    F.WriteBool('Filter', 'Filtered', btnradFiltred.Checked);
    F.WriteString('Filter', 'Name', edtName.Text);
    F.WriteString('Filter', 'SurName', edtSurName.Text);
    F.WriteString('Filter', 'AltSurName', edtAltSurName.Text);
    F.WriteString('Filter', 'City', edtCity.Text);
    F.WriteString('Filter', 'Street', edtStreet.Text);
    F.WriteString('Filter', 'StreetNo', edtStreetNo.Text);
    F.WriteString('Filter', 'ZIPCode', edtZIPCode.Text);
    F.WriteString('Filter', 'Prefix', edtPhonePrefix.Text);
    F.WriteString('Filter', 'PhoneNo', edtPhoneNo.Text);
  Finally
    F.Free;
  End;
End;
//******************* TfrmPersAgendBook.LoadSettings *************************

Procedure TfrmPersAgendBook.LoadSettings;
Var
  F                 : TIniFile;
Begin
  F := TIniFile.Create(ExtractFilePath(Application.ExeName) + 'Settings');
  Try
    chkIgnoreCase.Checked := F.ReadBool('Filter', 'IgnoreCase', True);
    chkPartialCompare.Checked := F.ReadBool('Filter', 'PartialCompare', True);
    btnradFiltred.Checked := F.ReadBool('Filter', 'Filtered', False);
    edtName.Text := F.ReadString('Filter', 'Name', '');
    edtSurName.Text := F.ReadString('Filter', 'SurName', '');
    edtAltSurName.Text := F.ReadString('Filter', 'AltSurName', '');
    edtCity.Text := F.ReadString('Filter', 'City', '');
    edtStreet.Text := F.ReadString('Filter', 'Street', '');
    edtStreetNo.Text := F.ReadString('Filter', 'StreetNo', '');
    edtZIPCode.Text := F.ReadString('Filter', 'ZIPCode', '');
    edtPhonePrefix.Text := F.ReadString('Filter', 'Prefix', '');
    edtPhoneNo.Text := F.ReadString('Filter', 'PhoneNo', '');
  Finally
    F.Free;
  End;
End;

End.

